=== debian/changelog ===
ecere-sdk (0.44.10-1) unstable; urgency=low

  [Jerome St-Louis]
  * Build-Depend on libjpeg-dev (Closes: #750066)
  * Build-Depedn on libpng-dev (Closes: #750068)
  * New upstream version (Closes: #749822, #766189)
   + Compiler fixes and optimizations
   + Better C99 compatibility (stdbool, complex numbers)
   + Fixed C integer promotion issues
   + Fixed and improved all samples (resources included)
   + Improved 3DS model support
   + EditBox and syntax highlighting fixes
   + Internationalization improvements
   + Clang and OS X Mavericks Support
   + More reliable IDE debugger watches
   + X11 full screen support
   + X11 acquired input support
   + X11 fixes (including improved fix for Unity)
   + Various bug fixes
   + Memory leaks fixes

  [Ondřej Surý]
  * Don't bump the versions in the symbols files

 -- Jerome St-Louis <jerstlouis@gmail.com>  Thu, 7 Aug 2014 17:00:00 -0500
